%define _catdir /var/cache/man
%global _hardened_build 0
%define major_version    4.4.3
%define patch_version P1

Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server/relay agent/client
Name:		dhcp
Version:		%{major_version}%{patch_version}
Release:	%mkrel 3
License:	ISC and MPLv2.0
Group:		System/Servers
URL:		https://www.isc.org/software/dhcp
Source0:	ftp://ftp.isc.org/isc/%{name}/%{name}-%{major_version}-%{patch_version}.tar.gz
Source1:	dhcpd6.conf
Source2:	dhcpd.conf
Source3:	dhcpd.init
Source4:	dhcp-dynamic-dns-examples.tar.bz2
Source5:	dhcrelay.init
Source6:	update_dhcp.pl
Source7:	dhcpreport.pl
Source8:	dhcpd-chroot.sh
Source9:	dhclient-exit-hooks
Source11:	dhclient-hook-static-routes
Source12:	draft-ietf-dhc-ldap-schema-01.txt
Source13:	dhcrelay6
Source14:	dhcrelay6.init
Source15:	dhcpd6.init
Source16:   dhclient-script

# mageia patches
Source100:	dhcp-4.2.2-ifup.patch
Patch101:	dhcp-4.3.4-fix-format-errors.patch
Patch103:	dhcp-4.2.5-P1-man.patch
# fedora patches
Patch2 :    0002-additional-dhclient-options.patch
Patch7:		dhcp-4.2.0-default-requested-options.patch
Patch9:     dhcp-garbage-in-format-string-error.patch
Patch10:    dhcp-4.4.3-close-on-exec.patch
Patch12 :   dhcp-RFC-3442-Classless-Static-Route-Option-for-DHCPv4-51.patch
Patch17:	dhcp-4.2.0-add_timeout_when_NULL.patch
Patch18 :   0018-No-subnet-declaration-for-iface-should-be-info-not-e.patch
Patch19:	dhcp-4.3.0-64_bit_lease_parse.patch
Patch22:    dhcp-dhclient-make-sure-link-local-address-is-ready-in-st.patch
Patch29:    CVE-2021-25220.patch
Patch24 :   dhcp-Detect-system-time-changes.patch
Patch25 :   dhcp-bind-Detect-system-time-changes.patch

BuildRequires:	perl groff-for-man
BuildRequires: lib64ldap2.4_2-devel
Provides:	dhcpd
Obsoletes:	dhcpd < 3.0.6
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Obsoletes: 	%name < %{version}

%description 
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network configuration
information (IP address, subnetmask, broadcast address, etc.) from a DHCP
server. The overall purpose of DHCP is to make it easier to administer a 
large network. The dhcp package includes the DHCP server and a DHCP relay
agent. You will also need to install the dhcp-client or dhcpcd package,
or pump or dhcpxd, which provides the DHCP client daemon, on client machines.

If you want the DHCP server and/or relay, you will also need to install the
dhcp-server and/or dhcp-relay packages.

%package common
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server
Group:		System/Servers

%description common
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

You will also need to install the dhcp-client or dhcpcd package, or pump or
dhcpxd, which provides the DHCP client daemon, on  client machines. If you
want the DHCP server and/or relay, you will also need to install the
dhcp-server and/or dhcp-relay packages.

%package doc
Summary:	Documentation about the ISC DHCP server/client
Group:		Documentation

%description doc
This package contains RFC/API/protocol documentation about the ISC
DHCP server and client.

DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

%package server
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server
Group:		System/Servers
Requires:	dhcp-common = %{version}-%{release}
Requires(post):	rpm-helper
Requires(preun): rpm-helper
Obsoletes:	dhcp < 3.0.6
Provides:	dhcp

%description server
DHCP server is the Internet Software Consortium (ISC) DHCP server for various
UNIX operating systems. It allows a UNIX mac hine to serve DHCP requests from
the network.

You should install dhcp-server if you want to set up a DHCP server on your
network. You will also need to install the base dhcp package.

%package client
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) client
Group:		System/Servers
Requires:	dhcp-common = %{version}-%{release}

%description client
DHCP client is the Internet Software Consortium (ISC) DHCP client for various
UNIX operating systems.  It allows a UNIX mac hine to obtain it's networking
parameters from a DHCP server.

You should install dhcp-client if you want to use the ISC DHCP client instead
of the Red Hat DHCP client, pump, or dhcpcd, or dhcpxd. You will also need to
install the base dhcp package.

%package relay
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) relay
Group:		System/Servers
Requires:	dhcp-common = %{version}-%{release}
Requires(post):	rpm-helper
Requires(preun): rpm-helper

%description relay
DHCP relay is the Internet Software Consortium (ISC) relay agent for DHCP
packets. It is used on a subnet with DHCP clients to "relay" their requests
to a subnet that has a DHCP server on it. Because DHCP packets can be
broadcast, they will not be routed off of the local subnet. The DHCP relay
takes care of this for the client. You will need to set the environment
variable SERVERS and optionally OPTIONS in /etc/sysconfig/dhcrelay before
starting the server.

%package keama
Summary:        Migration assistant from dhcp to kea
Group:		System/Servers
Requires:	dhcp-common = %{version}-%{release}
Requires(post):	rpm-helper
Requires(preun): rpm-helper

%description keama
This package provides a migration assistant for kea, the successor of the ISC
DHCP server.

%package devel
Summary:	Development headers and libraries for the dhcpctl API
Group:		Development/Libraries
Requires:	dhcp-common = %{version}-%{release}

%description devel
DHCP devel contains all of the libraries and headers for developing with the
Internet Software Consortium (ISC) dhcpctl API.

%prep
%setup -q -n %{name}-%{major_version}-%{patch_version}
pushd bind
tar -xvf bind.tar.gz
ln -s bind-9* bind
popd

%autopatch -p1

install -m0644 %{SOURCE12} doc

%build
#CFLAGS="{optflags} -std=c99"
autoreconf -fiv
%serverbuild
%configure2_5x \
    --enable-paranoia --enable-early-chroot \
    --with-ldapcrypto \
    --with-srv-lease-file=%{_var}/lib/dhcp/dhcpd.leases \
    --with-srv6-lease-file=%{_var}/lib/dhcp/dhcpd6.leases \
    --with-cli-lease-file=%{_var}/lib/dhcp/dhclient.leases \
    --with-cli6-lease-file=%{_var}/lib/dhcp/dhclient6.leases \
    --with-srv-pid-file=%{_var}/run/dhcpd/dhcpd.pid \
    --with-srv6-pid-file=%{_var}/run/dhcpd/dhcpd6.pid \
    --with-cli-pid-file=%{_var}/run/dhclient.pid \
    --with-cli6-pid-file=%{_var}/run/dhclient6.pid \
    --with-relay-pid-file=%{_var}/run/dhcrelay.pid  \
    --with-relay6-pid-file=%{_var}/run/dhcrelay6.pid  \
    --enable-log-pid  \
    --enable-binary-leases

%make_build -j1 -C keama
%make_build -j1 -C bind all
cat bind/configure.log
cat bind/build.log
cat bind/install.log
%make_build

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_var}/lib/dhcp
install -d %{buildroot}%{_var}/run/dhcpd

%make_install -C keama
%makeinstall_std

# Install correct dhclient-script
%{__install} -D -p -m 0755 %{SOURCE16} %{buildroot}/sbin/dhclient-script
%{__mkdir} -p %{buildroot}/sbin
%{__mv} %{buildroot}%{_sbindir}/dhclient %{buildroot}/sbin/dhclient


install -m0755 %{SOURCE3} %{buildroot}%{_initrddir}/dhcpd
install -m0755 %{SOURCE15} %{buildroot}%{_initrddir}/dhcpd6
install -m0755 %{SOURCE5} %{buildroot}%{_initrddir}/dhcrelay
install -m0755 %{SOURCE14} %{buildroot}%{_initrddir}/dhcrelay6
install -m0755 %{SOURCE6} %{SOURCE7} %{SOURCE8} %{SOURCE13} %{buildroot}%{_sbindir}/
install -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/
install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/
install -m0755 contrib/ldap/dhcpd-conf-to-ldap %{buildroot}%{_sbindir}/

# install exit-hooks script to /etc/
install -m 755 %{SOURCE9} %{buildroot}%{_sysconfdir}
install -d %{buildroot}%{_sysconfdir}/dhclient-exit-hooks.d
install -m 755 %{SOURCE11} %{buildroot}%{_sysconfdir}/dhclient-exit-hooks.d/static-routes.sh

cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd <<EOF
# You can set here various option for dhcpd

# Which configuration file to use.
# CONFIGFILE="/etc/dhcpd.conf"

# Where to store the lease state information.
# LEASEFILE="/var/lib/dhcp/dhcpd.leases"

# Define DHCPDARGS with any other options to pass to the dhcpd server.
# See dhcpd(8) for available options and syntax.
# OPTIONS="-q"
# DHCPDARGS="eth0 eth1"
DHCPDARGS=
OPTIONS=

EOF

cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd6 <<EOF
# You can set here various option for dhcpd

# Which configuration file to use.
# CONFIGFILE="/etc/dhcpd6.conf"

# Where to store the lease state information.
# LEASEFILE="/var/lib/dhcp/dhcpd6.leases"

# Define INTERFACES to limit which network interfaces dhcpd listens on.
# The default null value causes dhcpd to listen on all interfaces.
#INTERFACES=""

# Define DHCPDARGS with any other options to pass to the dhcpd server.
# See dhcpd(8) for available options and syntax.
# OPTIONS="-q"
# DHCPDARGS="eth0 eth1"
DHCPDARGS=
OPTIONS=
EOF

touch %{buildroot}%{_var}/lib/dhcp/dhcpd.leases
touch %{buildroot}%{_var}/lib/dhcp/dhclient.leases
touch %{buildroot}%{_var}/lib/dhcp/dhcpd6.leases
touch %{buildroot}%{_var}/lib/dhcp/dhclient6.leases

cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcrelay <<EOF
# The following variables are recognized:

# Define SERVERS with a list of one or more DHCP servers where
# DHCP packets are to be relayed to and from.  This is mandatory.
#SERVERS="10.11.12.13 10.9.8.7"
SERVERS=""

# Define OPTIONS with any other options to pass to the dhcrelay server.
# See dhcrelay(8) for available options and syntax.
#OPTIONS="-q -i eth0 -i eth1"
OPTIONS="-q"
EOF

cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcrelay6 <<EOF
# The following variables are recognized:

# Specifies the "lower" network interfaces list for DHCPv6 relay mode:
# the interfacea on which queries will be received from clients
# or from other relay agents. This is mandatory.
# See dhcrelay(8) for more information ('-l' option).
#LOWER_INTERFACES="eth0 2001:db8:1::1%eth1"
LOWER_INTERFACES=""

# Specifies the "upper" network interfaces list for DHCPv6 relay mode:
# the interfaces to which queries from clients and other relay
# agents should be forwarded. This is mandatory.
# See dhcrelay(8) for more information ('-u' option).
#UPPER_INTERFACES="eth2 2001:db8:2::1%eth3"
UPPER_INTERFACES=""

# Define OPTIONS with any other options to pass to the dhcrelay server.
# See dhcrelay(8) for available options and syntax.
OPTIONS="-q"
EOF

find . -type d -exec chmod 0755 {} \;
find . -type f -exec chmod 0644 {} \;

rm -rf doc/ja_JP.eucJP

# remove empty files
find -size 0 |grep ldap | xargs rm -rf 

# remove unwanted file
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/dhclient.conf
rm -f %{buildroot}%{_sysconfdir}/dhclient.conf.example
rm -f %{buildroot}%{_sysconfdir}/dhcpd.conf.example
rm -f %{buildroot}%{_libdir}/*.a

%post server
%_post_service dhcpd
# New dhcpd lease file
if [ ! -f %{_var}/lib/dhcp/dhcpd.leases ]; then
    touch %{_var}/lib/dhcp/dhcpd.leases
fi
if [ ! -f %{_var}/lib/dhcp/dhcpd6.leases ]; then
    touch %{_var}/lib/dhcp/dhcpd6.leases
fi

if [ $1 = 0 ]; then
	%{_initrddir}/dhcpd start
	%{_initrddir}/dhcpd6 startPatch14 : 0014-IPoIB-support-660681.patch
fi

#update an eventual installed dhcp-2* server
if [ -f %{_sysconfdir}/dhcpd.conf ]; then
	perl %{_sbindir}/update_dhcp.pl
fi

%preun server
%_preun_service dhcpd
%_preun_service dhcpd6

%postun server
if [ "$1" -ge "1" ]; then
    /sbin/service dhcpd condrestart >/dev/null 2>&1
    /sbin/service dhcpd6 condrestart >/dev/null 2>&1  
fi

%post relay
%_post_service dhcrelay
%_post_service dhcrelay6

%preun relay
%_preun_service dhcrelay
%_preun_service dhcrelay6

%postun relay
if [ "$1" -ge "1" ]; then
    /sbin/service dhcrelay condrestart >/dev/null 2>&1
    /sbin/service dhcrelay6 condrestart >/dev/null 2>&1
fi
		 
%post client
touch /var/lib/dhcp/dhclient.leases
touch /var/lib/dhcp/dhclient6.leases

%postun client
rm -rf /var/lib/dhcp/dhclient.leases
rm -rf /var/lib/dhcp/dhclient6.leases

%clean
rm -rf %{buildroot}

%files common
%defattr(-,root,root)
%dir %{_var}/lib/dhcp
%{_mandir}/man5/dhcp-options.5*

%files doc
%defattr(-,root,root)
%doc doc/*

%files server
%defattr(-,root,root)
%{_initrddir}/dhcpd
%{_initrddir}/dhcpd6
%config(noreplace) %{_sysconfdir}/dhcpd.conf
%config(noreplace) %{_sysconfdir}/dhcpd6.conf
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd6
%config(noreplace) %ghost %{_var}/lib/dhcp/dhcpd.leases
%config(noreplace) %ghost %{_var}/lib/dhcp/dhcpd6.leases
%{_sbindir}/dhcpd
%{_sbindir}/update_dhcp.pl
%{_sbindir}/dhcpreport.pl
%{_sbindir}/dhcpd-conf-to-ldap
%{_sbindir}/dhcpd-chroot.sh
%{_bindir}/omshell
%{_mandir}/man1/omshell.1*
%{_mandir}/man3/omapi.3*
%{_mandir}/man5/dhcpd.conf.5*
%{_mandir}/man5/dhcpd.leases.5*
%{_mandir}/man5/dhcp-eval.5*
%{_mandir}/man8/dhcpd.8*
%dir %{_var}/run/dhcpd

%files relay
%defattr(-,root,root)
%{_initrddir}/dhcrelay
%{_initrddir}/dhcrelay6
%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay
%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay6
%{_sbindir}/dhcrelay
%{_sbindir}/dhcrelay6
%{_mandir}/man8/dhcrelay.8*

%files client
%defattr(-,root,root)
%config(noreplace) %ghost %{_var}/lib/dhcp/dhclient.leases
%config(noreplace) %ghost %{_var}/lib/dhcp/dhclient6.leases
%attr (0755,root,root) /sbin/dhclient-script
/sbin/dhclient
%{_sysconfdir}/dhclient-exit-hooks
%{_sysconfdir}/dhclient-exit-hooks.d
%{_mandir}/man5/dhclient.conf.5*
%{_mandir}/man5/dhclient.leases.5*
%{_mandir}/man8/dhclient.8*
%{_mandir}/man8/dhclient-script.8*

%files keama
%{_sbindir}/keama
%{_mandir}/man8/keama.8*

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_mandir}/man3/*


%changelog
* Thu Feb 08 2024 yodelu - 4.4.3P1-3pclos2024
- build keama package
